/*
 * @(#)Graph.java	1.18 06/02/22
 */

/**
 * Graph.java
 * Ot킷NX
 * @author MegumiAraki
 * @date 2007/11/26
 */

import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Checkbox;
import java.awt.Dimension;
import java.awt.Panel;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.StringTokenizer;

public class Graph extends Applet implements ActionListener, ItemListener {

	GraphPanel panel;
	Panel controlPanel;

	Button scramble = new Button("Ot܂");
	Checkbox relatedWordSearch = new Checkbox("֘A܂߂Č");
	// Checkbox stress = new Checkbox("֘Ax\");//֘Ax\`FbN{bNX

	public void init() {
		// controlPanel.setBackground(HanabiSettings.GRAPH_BGCOLOR);
		setLayout(new BorderLayout());

		panel = new GraphPanel(this);
		add("Center", panel);
		controlPanel = new Panel();
		add("South", controlPanel);

		controlPanel.add(scramble);
		scramble.addActionListener(this);
		controlPanel.add(relatedWordSearch);
		relatedWordSearch.addItemListener(this);
		// controlPanel.add(stress);
		// stress.addItemListener(this);

		String edges = getParameter("edges");
		for (StringTokenizer t = new StringTokenizer(edges, ","); t
				.hasMoreTokens();) {

			String str = t.nextToken();// ЂƂ̃g[No
			int i = str.indexOf('-');// m[h̋؂蕶̈ʒuL^

			if (i > 0) {// ؂蕶킾

				// GbW̒̏ǂݍ
				int len = 50;// GbW̒50ɐݒ肷
				int j = str.indexOf('/');// AGbWݒLAL̈ʒuL^
				if (j > 0) {
					len = Integer.valueOf(str.substring(j + 1)).intValue();
					str = str.substring(0, j);
				}

				// em[h̏L^
				String node1 = str.substring(0, i);
				String node2 = str.substring(i + 1);

				// m[hP̎ނ̏ǂݍ
				int k = node1.indexOf(':');

				String node1Type = node1.substring(k + 1);
				node1 = node1.substring(0, k);

				// m[hQ̎ނ̏ǂݍ
				int l = node2.indexOf(':');

				String node2Type = node2.substring(l + 1);
				node2 = node2.substring(0, l);
				panel.addEdge(node1, node1Type, node2, node2Type, len);
			}
		}
		Dimension d = getSize();
		String center = getParameter("center");
		int i = center.indexOf(':');

		String centerType = center.substring(i + 1);
		center = center.substring(0, i);

		if (center != null) {
			Node n = panel.nodes[panel.findNode(center, centerType)];
			n.x = d.width / 2;
			n.y = d.height / 2;
			n.fixed = true;
		}
	}

	// Ot
	public void destroy() {
		remove(panel);
		remove(controlPanel);
	}

	// OtJn
	public void start() {
		panel.start();
	}

	// Ot~
	public void stop() {
		panel.stop();
	}

	// {^ꂽƂ̏s
	public void actionPerformed(ActionEvent e) {
		Object src = e.getSource();

		// XNu{^
		if (src == scramble) {
			play(getCodeBase(), "audio/computer.au");
			Dimension d = getSize();
			for (int i = 0; i < panel.nnodes; i++) {
				Node n = panel.nodes[i];
				if (!n.fixed) {
					n.x = 10 + (d.width - 20) * Math.random();
					n.y = 10 + (d.height - 20) * Math.random();
				}
			}
			return;
		}
	}

	// `FbN{bNXIꂽƂ̏s
	public void itemStateChanged(ItemEvent e) {
		Object src = e.getSource();
		boolean on = e.getStateChange() == ItemEvent.SELECTED;

		if (src == relatedWordSearch)// ֘A`FbN{bNX
			panel.relatedWordSearch = on;
		// else if (src == stress)// ֘Ax`FbN{bNX
		// panel.stress = on;
	}

	// Avbg̏\
	public String getAppletInfo() {
		return "Title: GraphLayout \nAuthor: Manekineko";
	}

	// Ot̃p[^̏\
	public String[][] getParameterInfo() {
		String[][] info = {
				{
						"edges",
						"delimited string",
						"A comma-delimited list of all the edges.  It takes the form of 'C-N1,C-N2,C-N3,C-NX,N1-N2/M12,N2-N3/M23,N3-NX/M3X,...' where C is the name of center node (see 'center' parameter) and NX is a node attached to the center node.  For the edges connecting nodes to each other (and not to the center node) you may (optionally) specify a length MXY separated from the edge name by a forward slash."},
				{"center", "string", "The name of the center node."}};
		return info;
	}

}
