package searcher;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.HashMap;

import org.xml.sax.Attributes;
import org.xml.sax.helpers.DefaultHandler;

import hanabisetting.HanabiSettings;

class NameHandler extends DefaultHandler {

	StringBuffer buf = new StringBuffer();
	ArrayList<String> nameLists = new ArrayList<String>();
	int sequence = 0;
	private ArrayList<TeacherCount> teacherCount = new ArrayList<TeacherCount>();

	public void startDocument() {
		System.out.println("Starst Handler");
	}

	public void endDocument() {
		System.out.println("Stop Handler");
	}

	public void startElement(String uri, String localName, String qName,
			Attributes attrs) {
		if (qName.equals("Summary")) {
			sequence = 1;
		} else if (qName.equals("Title")) {
			sequence = 1;
		} else {
			sequence = 0;
		}
	}

	public void endElement(String uri, String localName, String qName,
			Attributes attrs) {
	}

	public void characters(char[] ch, int offset, int length) {
		String str = new String(ch, offset, length);
		ArrayList<String> nameList = new ArrayList<String>();
		if (sequence == 1) {
			nameList = read(str);
			ArrayList<TeacherCount> test = getTeacherList(nameList);
			setTeacherCount(test);
		}
	}

	/*
	 * 
	 */
	private ArrayList<TeacherCount> getTeacherList(ArrayList<String> nameList) {
		// OƏo񐔂̃ZbgXg
		ArrayList<TeacherCount> teachersList = new ArrayList<TeacherCount>();

		// OƓY}b`
		HashMap<String, Integer> hash = new HashMap<String, Integer>();

		// Y
		int increment = 0;

		// o񐔂𒲂ׂ
		for (int i = 0; i < nameList.size(); i++) {
			if (hash.containsKey(nameList.get(i))) {
				int arrKey = (Integer) hash.get(nameList.get(i));
				TeacherCount tc = teachersList.get(arrKey);
				int currentNum = tc.getNum() + 1;
				tc.setNum(currentNum);
			} else {
				hash.put(nameList.get(i), increment);
				teachersList.add(new TeacherCount(nameList.get(i), 1));
				increment++;
			}
		}

		// o񐔂ёւ
		for (int i = 0; i < teachersList.size(); i++) {
			for (int k = teachersList.size() - 1; k > i; k--) {
				if (teachersList.get(i).getNum() < teachersList.get(k).getNum()) {
					TeacherCount temp = (TeacherCount) teachersList.get(k)
							.clone();
					teachersList.set(k, teachersList.get(i));
					teachersList.set(i, temp);
				}
			}
		}
		return teachersList;
	}

	/*
	 * ǂ
	 */
	public ArrayList<String> read(String str) {
		// f[^tH_̐΃pX擾
		String path=HanabiSettings.DATA_DIR;
		final String DICTIONARY = path + "dictionary.txt"; 
		
		File dict = new File(DICTIONARY);
		if(!dict.exists()){
			System.out.println("Dictionary File Not Found");
			return null;
		}
		else if(!dict.canRead()){
			System.out.println("Cannot Read Dictionary File");
			return null;
		}
		else{
		try {
			FileInputStream dictionary = new FileInputStream(DICTIONARY);
			InputStreamReader nameDictionary;
			try {
				nameDictionary = new InputStreamReader(dictionary, "Shift-Jis");
				BufferedReader buffer = new BufferedReader(nameDictionary);
				String line;
				try {
					while ((line = buffer.readLine()) != null) {
						if (str.matches(".*" + line + ".*")) {
							nameLists.add(line);
						}
					}
					return nameLists;
				} catch (IOException e) {
					e.printStackTrace();
				}
			} catch (UnsupportedEncodingException e) {
				e.printStackTrace();
			}

		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		return null;
		}
	}
	public ArrayList<TeacherCount> getTeacherCount() {
		return teacherCount;
	}

	public void setTeacherCount(ArrayList<TeacherCount> teacherCount) {
		this.teacherCount = teacherCount;
	}

}
